#include <amxmodx>
#include <amxmisc>
#include <float>

#define PLUGIN "Empty Server"
#define VERSION "0.1"
#define AUTHOR "Kittie"

new curtime = 0, emptyWaitTime = 0, minPlayers = 0
new mapList[512], map[51]
new Array:maps
new g_pCvarEmptyWaitTime, g_pCvarEmptyMinPlayers, g_pCvarMaps

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	// cvar
	g_pCvarEmptyWaitTime 	= register_cvar("amx_emptytime","120")
	g_pCvarEmptyMinPlayers	= register_cvar("amx_emptyminplayers","5")
	g_pCvarMaps 		= register_cvar("amx_empty_maps", "de_dust2_2x2 de_inferno de_nuke")
}

public plugin_cfg()
{
	// ,         
	emptyWaitTime = get_pcvar_num(g_pCvarEmptyWaitTime)

	//   ,     
	minPlayers = get_pcvar_num(g_pCvarEmptyMinPlayers) 	

	//      
	get_pcvar_string(g_pCvarMaps, mapList, charsmax(mapList))

	// 
        maps = ArrayCreate(charsmax(map));

	//    ( - )
	while (mapList[0] != 0 && strtok(mapList, map, charsmax(map), mapList, charsmax(mapList), ' '))
	{
		//  
		trim(map)
		trim(mapList)
				
		//    
		ArrayPushString(maps, map)
	}

	//  
	if(ArraySize(maps) == 0)
	{
		log_amx("Where is no maps for empty server, plugin will be disabled.")
	}
	else
	{
        	//    
		set_task(1.0, "ticktimer", 0, _, _, "b", 1)
	}
}

public plugin_end( )
{
	// 
	ArrayDestroy(maps);
}

public ticktimer()
{
	new players,i
	players = get_playersnum()

	//   .  HLTV
	for(i=1; i<=get_maxplayers(); i++)
	{
		if(is_user_hltv(i))
			players--
	}

	//       
	if(players < minPlayers)
	{
		curtime ++
		if(curtime >= emptyWaitTime)
			change_maps()
	}
	else
		curtime = 0
	
	return curtime
}

public change_maps()
{
	new curmap[51]
	get_mapname(curmap, 50)

	new mapIdx = 0
	do 
	{
		mapIdx = random_num(0, ArraySize(maps) - 1)
		ArrayGetString(maps, mapIdx, map, charsmax(map))
	}
	while(equali(map, curmap) && ArraySize(maps) > 1)
	
	//   
	log_amx("Map will be changed to %s on empty server.", map);
	
	//  		
	server_cmd("changelevel %s", map)
	
	return PLUGIN_HANDLED
}